#include <openssl/pem.h>
#include "evp_public_key.hpp"
#include "evp_bio.hpp"

evp_public_key_t evp_public_key_t::from_pem(const std::string & pem) {
	evp_bio_t buffer(BIO_s_mem());
	buffer.write(pem);
	return evp_public_key_t(
		PEM_read_bio_PUBKEY(
			const_cast<BIO *>(buffer.data()), // OpenSSL doesn't understand const
			nullptr,
			nullptr,
			nullptr
		)
	);
}
