#include <system_error>
#include "license_file.hpp"

extern "C" int xlic_list_licenses(
	struct xlic_license_list ** list,
	const char * filename
) {
	*list = nullptr;
	try {
		const license_file license_bin(filename);
		*list = license_bin.export_list();
		return EXIT_SUCCESS;
	} catch (std::system_error & e) {
		fprintf(stderr, "Error: %s\n", e.what());
		return e.code().value();
	} catch (std::exception & e) {
		fprintf(stderr, "Error: %s\n", e.what());
	}
	return EINVAL;
}
