#include "public_key.hpp"

const public_key_t public_key_t::invalid;

std::string public_key_t::to_pem() const {
	static const char * begin = "-----BEGIN PUBLIC KEY-----\n";
	static const size_t begin_length = strlen(begin);
	static const char * end = "\n-----END PUBLIC KEY-----";
	static const size_t end_length = strlen(end);
	const std::string encoded(to_base64());
	const size_t line_count = ((encoded.length() - 1) / 64);
	std::string output;
	output.reserve(begin_length + encoded.length() + (line_count) + end_length);
	output.append(begin, begin_length);
	for (size_t i = 0; i < line_count; i++) {
		output.append(encoded.data() + (i * 64), 64);
		output += '\n';
	}
	output.append(encoded.data() + ((line_count) * 64), encoded.length() - (line_count * 64));
	output.append(end, end_length);
	return output;
}
